const Model = require('../model');
const View = require('../view');

const fs = require('fs');

const shell = require('shelljs');

let actionStatus = [];

async function runActions(state, actions){
  View.destroy();
  console.log("Running Actions");
  let count = 0;
  for(action of actions){
    count++;
    console.log(`____Action ${count}____`);
    let description = false;
    try {
      switch (action.type) {
        case "generate": {
          await generateFile(state);
          break;
        }
        case "bash": {
          const bash = (typeof action.exec === 'function') ? action.exec(state) : action.exec;
          if(action.require){
            if (!shell.which(action.require)) {
              throw `This script requires ${action.require}`;
            }
          }
          console.log(`- Running bash command ${bash}`);
          shell.exec(bash);
        }
      }
    }
    catch (err) {
      console.log('Error - '+err.message);
    }
    // View.updateState(actionStatus);
    await setTimeout(() => {}, 30000);
  }
  setTimeout(() => {
    process.exit(0);
  }, 3000);
}

async function generateFile(state){
  const file = Model.getFile();

  const gen = require(process.cwd() + '/' + file).generate(state);

  console.log(`- Generating File ${gen.path+gen.file}`);

  await writeFile(gen.path+gen.file, gen.content);
}

async function writeFile(file, content){
  await fs.writeFileSync(file, content);
}

module.exports = {
  runActions
}