#!/usr/bin/env node

const prompt = require('prompt-sync')();

const program = require('commander');

const shell = require('shelljs');

const Controller = require('./controller');

const actionsHelper = require('./actions');

const prettyjson = require('prettyjson');

const chalk = require('chalk');

const View = require('./view');

const Model = require('./model');

View.init();

console.reset = function () {
  //return process.stdout.write('\033c');
}

program
.arguments('<file>')
.option('-d, --dryRun', 'Dry run generation')
.option('-v, --verbose', 'Give many details')
.action(function(file) {
  start(file);
})
.parse(process.argv);

/**
 * Render Title
 */
function renderTitle(text){
  //console.log(chalk.black.bgWhite.bold(text));
}

/**
 * Initiate collection of state and run actions
 */
async function start(file){
  //console.reset();
  const state = {};
  const paramsConfig = require(process.cwd()+'/'+file).getState().params;
  const actionsConfig = require(process.cwd()+'/'+file).getState().actions;

  for(var i = 0; i<paramsConfig.length; i++){
    // if(paramsHelper[paramsConfig[i].type]){
    //   params[paramsConfig[i].id] = await paramsHelper[paramsConfig[i].type].get(paramsConfig[i]);
    // }
    // else{
    //   params[paramsConfig[i].id] = await paramsHelper.string.get(paramsConfig[i]);
    // }
    // //console.reset();
    // console.log('Params: ');
    // console.log(prettyjson.render(params));
    state[paramsConfig[i].id] = '';
  }

  Model.setParams(paramsConfig);
  Model.setActions(actionsConfig);
  Model.setState(state);
  Model.setFile(file);
  // view.updateState(params);
  Controller.get('params').startStateInput();



  // view.loadInput();
  // if(program.verbose) // console.log('Generation Params: ', params);

  // try {
  //   const gen = require(process.cwd() + '/' + file).generate(params);
  //
  //   if(program.dryRun){
  //     //console.log(`The following file '${gen.path+gen.file}' would be saved:`);
  //     // console.log(gen.content);
  //   }
  //   else{
  //     actionsHelper.writeFile(gen.path+gen.file, gen.content);
  //     // console.log(`Saving file '${gen.path+gen.file}'`);
  //   }
  //
  //   for(var i = 0; i<actionsConfig.length; i++){
  //     if(actionsConfig[i].require){
  //       if (!shell.which(actionsConfig[i].require)) {
  //         shell.echo('Sorry, this script requires '+actionsConfig[i].require);
  //         shell.exit(1);
  //       }
  //     }
  //     if(typeof actionsConfig[i].exec === 'function') shell.exec(actionsConfig[i].exec(params))
  //     else shell.exec(actionsConfig[i].exec)
  //   }
  // }
  // catch(err){
  //   console.log(err);
  // }

  //process.exit();

}

function getParams(){
  return params;
}

module.exports = {
  getParams
}