
const View = require('./view');

const Controller = require('./controller');

let state = false;

let actions = false;

let params = false;

let file = false;

let location = [];

let arrayPos = 0;

let log = '';

/**
 * Initialise the input location
 */
function initLocation(){
  location[0] = params[0].id;
}

/**
 * Set parameters
 */
function setParams(newParams){
  params = newParams;
  initLocation();
}

/**
 * Set actions
 */
function setActions(newActions){
  actions = newActions;
}

/**
 * Set state
 */
function setState(newState){
  state = newState;
  updateState();
}

/**
 * Set the file name ran in the command
 */
function setFile(newFile){
  file = newFile;
}

function getFile(){
  return file;
}

/**
 * Set params
 */
function setParam(data){
  const locationString = location.map(item => (JSON.stringify([item]))).join('');
  eval('state'+locationString+' = '+JSON.stringify(data));
  updateState();
}

/**
 * Updates the state in the view
 */
function updateState(){
  View.updateState(state);
  // Use for debug
  // View.updateState(Object.assign(state, {location, log: JSON.stringify(log)+JSON.stringify(getCurrentParam())}));
}

/**
 * Set the next location
 */
function nextLocation(){
  const next = getNextParam();
  if(!next){
    if(outLocation()){
      updateState();
    }
    return;
  }
  else{
    location[location.length - 1] = next.id;
  }
  updateState();
}

/**
 * Set the previous location TODO
 */
function previousLocation(){
  let count = 0;
  let newIndex = 0;
  for(param of params){
    if (param.id == location[location.length - 1]) newIndex = count - 1;
    count++;
  }
  location[location.length - 1] = getNextParam().id; // TODO Make minus
  updateState();
}

/**
 * Return the next param config
 */
function getNextParam(index){
  let curParam = params;
  let count = 0;
  let skip = false;
  let found = false;

  for(index of location) {
    if(curParam.items) curParam = curParam.items;
    if(typeof curParam == 'number'){
      curParam = curParam[param];
    }
    for (param of curParam) {
      if (skip) {
        curParam = param;
        found = true;
        skip = false;
      }
      if (param.id == index){
        if (location.length != (count+1)) curParam = param;
        else{
          skip = true;
        }
      }
    }
    count++;
  }
  return found ? curParam : false;
}

/**
 * Return current param config
 */
function getCurrentParam(){
  let curParam = params;
  let count = 0;

  for(index of location) {
    if(curParam.items) curParam = curParam.items;
    if(typeof curParam == 'number'){
      curParam = curParam[param];
    }
    for (param of curParam) {
      if (param.id == index) curParam = param;
    }
    count++;
  }
  return curParam;
}

/**
 * Navigate in location (Array)
 */
function inLocation(){
  const curParam = getCurrentParam();
  const locationString = location.map(item => (JSON.stringify([item]))).join('');
  const length = eval('state'+locationString+'.length');

  // Set empty array/object for inserting data TODO add param props each time
  if(length == 0){
    eval('state'+locationString+' = [{}]');
  }
  else{
    eval('state'+locationString+'.push({})');
  }

  // Add Location details
  location.push(length);
  location.push(curParam.items[0].id);
  updateState();
}

/**
 * Navigate out location (Array)
 */
function outLocation(){
  arrayPos++; // TODO set changable
  delete location[location.length - 2];
  delete location[location.length - 1];
  if((location.length - 2)>=0) {
    location.length = location.length - 2;
    updateState();
  }
  else{
    Controller.get('actions').runActions(state, actions);
    return false;
  }
  return true;
}

module.exports = {
  setParams,
  setActions,
  setState,
  setFile,
  getFile,
  nextLocation,
  previousLocation,
  inLocation,
  getCurrentParam,
  setParam
}
